/*---------------------------------------------------------------------------*
  Project:  NitroSDK - MB - demos - fake_child
  File:     common.c

  Copyright 2003,2004 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: common.c,v $
  Revision 1.1  2004/11/22 13:01:10  takano_makoto
  Save as identical to multiboot-model file

  $NoKeywords: $
 *---------------------------------------------------------------------------*/


#include <nitro.h>

#include "common.h"
#include "disp.h"

static void VBlankIntr( void );

/*
 * Common functionality used throughout the demos.
 */
static u16 padPress;
static u16 padTrig;

/*---------------------------------------------------------------------------*
  Name:         ReadKey

  Description:  Processing for key reading

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void ReadKey( void )
{
    u16 currData = PAD_Read();
    
    padTrig = (u16)( ~padPress & currData );
    padPress = currData;
}

/*---------------------------------------------------------------------------*
  Name:         GetPressKey

  Description:  Get hold key

  Arguments:    None

  Returns:      Bitmap indicating keys held 
 *---------------------------------------------------------------------------*/
u16 GetPressKey( void )
{
    return padPress;
}


/*---------------------------------------------------------------------------*
  Name:         GetTrigKey

  Description:  Get key trigger

  Arguments:    None

  Returns:      Key trigger bitmap 
 *---------------------------------------------------------------------------*/
u16 GetTrigKey( void )
{
    return padTrig;
}


/*---------------------------------------------------------------------------*
  Name:         CommonInit

  Description:  Performs common initialization 

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
void CommonInit( void )
{
    /* Initialize OS */
    OS_Init();
    OS_InitTick();
    OS_InitAlarm();
    FX_Init();
    
    /* Initialize GX */
    GX_Init();
    GX_DispOff();
    GXS_DispOff();
    
    /* Set V blank interrupts */
    (void)OS_SetIrqFunction( OS_IE_V_BLANK, VBlankIntr );
    (void)OS_EnableIrqMask( OS_IE_V_BLANK );
    (void)OS_EnableIrqMask( OS_IE_FIFO_RECV );
    (void)GX_VBlankIntr( TRUE );
    
    {   /* Initialize FS */
        static u32 fs_tablework[0x100 / 4];
        FS_Init(FS_DMA_NOT_USE);
        (void)FS_LoadTable(fs_tablework, sizeof(fs_tablework));
    }
    
    // Read one blank key 
    ReadKey();
}


/*---------------------------------------------------------------------------*
  Name:         InitAllocateSystem

  Description:  Initializes the memory allocation system in the main memory arena.
  
  Arguments:    None.

  Returns:      None.
 *---------------------------------------------------------------------------*/
void InitAllocateSystem( void )
{
    void*           tempLo;
    OSHeapHandle    hh;

    // Assume that OS_Init was called 
    tempLo = OS_InitAlloc( OS_ARENA_MAIN ,
                           OS_GetMainArenaLo() ,
                           OS_GetMainArenaHi() ,
                           1 );
    OS_SetArenaLo( OS_ARENA_MAIN, tempLo );
    hh = OS_CreateHeap( OS_ARENA_MAIN , 
                        OS_GetMainArenaLo() ,
                        OS_GetMainArenaHi() );
    if ( hh < 0 )
    {
        OS_Panic("ARM9: Fail to create heap...\n");
    }
    hh = OS_SetCurrentHeap( OS_ARENA_MAIN, hh );
}




/*---------------------------------------------------------------------------*
  Name:         VBlankIntr

  Description:  Get key trigger

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
static void VBlankIntr( void )
{
    DispVBlankFunc();
    
    //---- Interrupt check flag 
    OS_SetIrqCheckFlag( OS_IE_V_BLANK );
}



